#include <16F877.h>
#device ICD=TRUE
#device adc=10

#FUSES NOWDT                    //No Watch Dog Timer
#FUSES HS                       //High speed Osc (> 4mhz for PCM/PCH) (>10mhz for PCD)
#FUSES NOPUT                    //No Power Up Timer
#FUSES NOPROTECT                //Code not protected from reading
#FUSES BROWNOUT                 //Reset when brownout detected
#FUSES NOLVP                    //No low voltage prgming, B3(PIC16) or B5(PIC18) used for I/O
#FUSES NOCPD                    //No EE protection
#FUSES NOWRT                    //Program memory not write protected
#FUSES NODEBUG                  //No Debug mode for ICD

#use delay(clock=20000000)
#use i2c(Master,Fast,sda=PIN_C4,scl=PIN_C3,force_hw)

#define Edit_SW   PIN_A0
#define Up_SW     PIN_A1
#define Down_SW   PIN_A2
#define Right_SW  PIN_A3
#define Left_SW   PIN_A4
#define Ent_SW    PIN_A5
#define LCD_E     PIN_D0
#define LCD_RS    PIN_D1
#define LCD_R/W   PIN_D2
#define LCD_DB0   PIN_D4
#define LCD_DB1   PIN_D5
#define LCD_DB2   PIN_D6
#define LCD_DB3   PIN_D7

#use    fast_io(A)
#use    fast_io(C)
#use    fast_io(D)

#byte   PORTA = 0x05
#byte   PORTB = 0x06
#byte   PORTC = 0x07
#byte   TRISA = 0x85
#byte   TRISA = 0x86
#byte   TRISC = 0x87
