/* LCD Library Customize (lcd_lib_G1.c)
   2008/06/13 By GucciTech / Chojiro Higashiguchi

   LCD Disp Control Library
   The internal organs function is as follows. 
      lcd_init()    ----- LCD Initialize
      lcd_cmd(cmd)  ----- Command Out
      lcd_data(chr) ----- 1 Character Disp Out
      lcd_clear()   ----- All Clear
   LCD Interface Use PORTD
*/


//////// Data Out Sub Function
void lcd_out(int code, int flag)
{
  output_D((code & 0xF0) | (input_D() & 0x0F));
  if (flag == 0)
    output_high(LCD_RS);   //For the indicative data
  else
    output_low(LCD_RS);    //For the command data
  delay_cycles(1);     //NOP    
  output_high(LCD_E);    //strobe out
  delay_cycles(2);     //NOP
  output_low(LCD_E);     //reset strobe
}
//////// 1 Character Disp Function
void lcd_data(int asci)
{
  lcd_out(asci, 0);    //High rank 4-bit power output
  lcd_out(asci<<4, 0); //Subordinate position 4-bit power output
  delay_us(50);        //50us Wait
}
/////// Command Out Function
void lcd_cmd(int cmd)
{
  lcd_out(cmd, 1);     //High rank 4-bit power output
  lcd_out(cmd<<4, 1);  //Subordinate position 4-bit power output
  delay_ms(2);         //2msec Wait
}
/////// All Clear Function
void lcd_clear()
{
  lcd_cmd(0x01);       //Initialize Command OUT
  delay_ms(15);        //15msec Wait
}
/////// Initialize Function
void lcd_init()
{
  set_tris_D(LCD_mode);    //Mode Set
  delay_ms(15);
  lcd_out(0x30, 1);    //8bit mode set
  delay_ms(5);
  lcd_out(0x30, 1);    //8bit mode set
  delay_ms(1);
  lcd_out(0x30, 1);    //8bit mode set
  delay_ms(1);
  lcd_out(0x20, 1);    //4bit mode set
  delay_ms(1);
  lcd_cmd(0x2E);       //DL=0 4bit mode
  lcd_cmd(0x08);       //display off C=D=B=0
  lcd_cmd(0x0D);       //display on B=D=1 C=0
  lcd_cmd(0x06);       //entry I/D=1 S=0
  lcd_cmd(0x02);       //cursor home
}


